/**
 *	@file ../Decompress64Src.h
 *	@brief file in header, generated from '../Decompress64.h'
 *		stored as plain text
 *	@date 2017-05-18 09:48:38
 *	@author FileToHeader (built Nov 11 2013)
 */

#pragma once
#ifndef _____DECOMPRESS64_H_INCLUDED
#define _____DECOMPRESS64_H_INCLUDED

/**
 *	@brief file in header, generated from '../Decompress64.h'
 */
class CDecompress64_h {
public:
	/**
	 *	@brief gets size of the data
	 *	@return Returns size of the data, in bytes, not including the terminating zero.
	 */
	static inline size_t n_Size()
	{
		return 10037;
	}

	/**
	 *	@brief determines whether the stored string is dynamically allocated
	 *	@return Returns true if the caller of p_Data() needs to free the memory.
	 */
	static inline bool b_Dynamic()
	{
		return false;
	}

	/**
	 *	@brief gets CRC32
	 *	@return Returns CRC32, or zero in case the data was modified (CRC not available).
	 */
	static inline uint32_t n_CRC32()
	{
		return 0x2f9cf3b1;
	}

	/**
	 *	@brief gets data
	 *
	 *	@return Returns data of the file on success, 0 on failure (not enough memory).
	 *
	 *	@note The data (although may be binary), is additionally null terminated to make
	 *		it easier to use (the terminating null is not counted in n_Size()).
	 *	@note See also b_Dynamic().
	 */
	static inline const char *p_Data()
	{
		const char *p_s_text =
			/*   1 */ "	/**\n"
			/*   2 */ "	 *	@brief calculates reverse prediction on a single image plane\n"
			/*   3 */ "	 *\n"
			/*   4 */ "	 *	@param[in,out] p_buffer is pointer to image plane data (just the d"
			/*   4 */ "ata, no padding or align)\n"
			/*   5 */ "	 *	@param[in] n_width is image width, in pixels\n"
			/*   6 */ "	 *	@param[in] n_height is image height, in pixels\n"
			/*   7 */ "	 *	@param[in] n_pred_type is predictor type (one of 0 = up, 1 = left,"
			/*   7 */ " 2 = avg, 3 = paeth, 4 = med,\n"
			/*   8 */ "	 *		5 = gap, 6 = no prediction, 7 = up-left, 8 = avg2, 9 = diff, 1"
			/*   8 */ "0 = grad-h, 11 = grad-v)\n"
			/*   9 */ "	 */\n"
			/*  10 */ "	static void UnPredict_ImagePlane(uint8_t *p_buffer, int n_width, int n_h"
			/*  10 */ "eight, int n_pred_type)\n"
			/*  11 */ "	{\n"
			/*  12 */ "		int n_first_row = (n_pred_type == 1 || n_pred_type == 6)? 0 : ((n_pr"
			/*  12 */ "ed_type == 5)? 2 : 1);\n"
			/*  13 */ "		int n_first_col = (n_pred_type == 0 || n_pred_type == 6)? 0 : ((n_pr"
			/*  13 */ "ed_type == 5)? 2 : 1);\n"
			/*  14 */ "		for(int x = 0; x < n_first_col; ++ x) {\n"
			/*  15 */ "			for(int y = n_first_row + 1; y < n_height; ++ y)\n"
			/*  16 */ "				p_buffer[x + n_width * y] += p_buffer[x + n_width * (y - 1)]"
			/*  16 */ ";\n"
			/*  17 */ "		}\n"
			/*  18 */ "		for(int y = 0; y < n_first_row; ++ y) {\n"
			/*  19 */ "			for(int x = n_first_col + 1; x < n_width; ++ x)\n"
			/*  20 */ "				p_buffer[x + n_width * y] += p_buffer[(x - 1) + n_width * y]"
			/*  20 */ ";\n"
			/*  21 */ "		}\n"
			/*  22 */ "		p_buffer += n_first_col + n_first_row * n_width;\n"
			/*  23 */ "		for(int y = n_first_row; y < n_height; ++ y, p_buffer += n_first_col"
			/*  23 */ ") {\n"
			/*  24 */ "			for(int x = n_first_col; x < n_width; ++ x, ++ p_buffer) {\n"
			/*  25 */ "				if(n_pred_type == 0)\n"
			/*  26 */ "					*p_buffer += p_buffer[-n_width]; // up\n"
			/*  27 */ "				else if(n_pred_type == 1)\n"
			/*  28 */ "					*p_buffer += p_buffer[-1]; // left\n"
			/*  29 */ "				else if(n_pred_type == 2) {\n"
			/*  30 */ "					*p_buffer += (int(p_buffer[-1]) + int(p_buffer[-n_width]"
			/*  30 */ ") +\n"
			/*  31 */ "						int(p_buffer[-1 - n_width])) / 3; // avg\n"
			/*  32 */ "				} else if(n_pred_type == 3) {\n"
			/*  33 */ "					int a = p_buffer[-1], b = p_buffer[-n_width], c = p_buff"
			/*  33 */ "er[-1 - n_width];\n"
			/*  34 */ "					int p = a + b - c, pa = abs(p - a), pb = abs(p - b), pc "
			/*  34 */ "= abs(p - c);\n"
			/*  35 */ "					*p_buffer += (pa <= pb && pa <= pc)? a : ((pb <= pc)? b "
			/*  35 */ ": c); // paeth\n"
			/*  36 */ "				} else if(n_pred_type == 4) { // med\n"
			/*  37 */ "					int a = p_buffer[-1], b = p_buffer[-n_width], c = p_buff"
			/*  37 */ "er[-1 - n_width];\n"
			/*  38 */ "					*p_buffer += (c >= max(a, b))? min(a, b) : (c <= min(a, "
			/*  38 */ "b))? max(a, b) : a + b - c;\n"
			/*  39 */ "				} else if(n_pred_type == 5) { // gap\n"
			/*  40 */ "					int n_not_last_col = (x + 1 != n_width)? 1 : 0; // the l"
			/*  40 */ "ast column extended right\n"
			/*  41 */ "					int nne = p_buffer[n_not_last_col - 2 * n_width], n = p_"
			/*  41 */ "buffer[-n_width], w = p_buffer[-1],\n"
			/*  42 */ "						ww = p_buffer[-2], nn = p_buffer[-2 * n_width], ne ="
			/*  42 */ " p_buffer[n_not_last_col - n_width],\n"
			/*  43 */ "						nw = p_buffer[-1 - n_width], n_d = abs(w - nw) + abs"
			/*  43 */ "(n - nn) +\n"
			/*  44 */ "						abs(ne - nne) - abs(w - ww) - abs(n - nw) - abs(n - "
			/*  44 */ "ne), n_ad = abs(n_d);\n"
			/*  45 */ "					uint8_t f = (w + n) / 2 + (ne - nw) / 4, g = (n_d > 0)? "
			/*  45 */ "w : n;\n"
			/*  46 */ "					*p_buffer += (n_ad > 80)? g : (n_ad > 32)? (f + g) / 2 :"
			/*  46 */ " (n_ad > 8)? (3 * f + g) / 4 : f;\n"
			/*  47 */ "				} else if(n_pred_type == 7) // 6 = no prediction\n"
			/*  48 */ "					*p_buffer += p_buffer[-1 - n_width]; // up-left\n"
			/*  49 */ "				else if(n_pred_type == 8)\n"
			/*  50 */ "					*p_buffer += (int(p_buffer[-1]) + int(p_buffer[-n_width]"
			/*  50 */ ")) / 2; // avg2\n"
			/*  51 */ "				else if(n_pred_type == 9)\n"
			/*  52 */ "					*p_buffer += p_buffer[-1] + p_buffer[-n_width] - p_buffe"
			/*  52 */ "r[-1 - n_width]; // diff\n"
			/*  53 */ "				else if(n_pred_type == 10)\n"
			/*  54 */ "					*p_buffer += p_buffer[-1] + (p_buffer[-n_width] - p_buff"
			/*  54 */ "er[-1 - n_width]) / 2; // grad-h\n"
			/*  55 */ "				else if(n_pred_type == 11)\n"
			/*  56 */ "					*p_buffer += p_buffer[-n_width] + (p_buffer[-1] - p_buff"
			/*  56 */ "er[-1 - n_width]) / 2; // grad-v\n"
			/*  57 */ "			}\n"
			/*  58 */ "		}\n"
			/*  59 */ "	}\n"
			/*  60 */ "\n"
			/*  61 */ "	/**\n"
			/*  62 */ "	 *	@brief decompresses the image\n"
			/*  63 */ "	 *\n"
			/*  64 */ "	 *	@param[in] p_s_base64 is null-terminated string containing BASE64 "
			/*  64 */ "compressed image data\n"
			/*  65 */ "	 *	@param[in] n_image_width is image width, in pixels\n"
			/*  66 */ "	 *	@param[in] n_image_height is image height, in pixels\n"
			/*  67 */ "	 *	@param[in] n_huff_stage_size size of the compressed data before Hu"
			/*  67 */ "ffman encoding\n"
			/*  68 */ "	 *	@param[in] n_predictor_y is predictor type for the luminance plane"
			/*  68 */ "\n"
			/*  69 */ "	 *	@param[in] n_predictor_uv is predictor type for the chrominance pl"
			/*  69 */ "ane\n"
			/*  70 */ "	 *	@param[in] n_predictor_a is predictor type for the alpha plane\n"
			/*  71 */ "	 *	@param[in] n_subsample is number of chrominance samples per \n"
			/*  72 */ "	 *	@param[in] n_color_type is color type bitmask (if the first bit is"
			/*  72 */ " set the image is\n"
			/*  73 */ "	 *		grayscale, if the second bit is set the image has alpha channe"
			/*  73 */ "l, if the third\n"
			/*  74 */ "	 *		bit is set, lossless compression was employed)\n"
			/*  75 */ "	 */\n"
			/*  76 */ "	static uint32_t *p_Decode_RLE_Huff_Base64(const char *p_s_base64,\n"
			/*  77 */ "		int n_image_width, int n_image_height, size_t n_huff_stage_size,\n"
			/*  78 */ "		int n_predictor_y, int n_predictor_uv, int n_predictor_a,\n"
			/*  79 */ "		int n_subsample, int n_color_type)\n"
			/*  80 */ "	{\n"
			/*  81 */ "		bool b_gray = (n_color_type & 1) != 0, b_alpha = (n_color_type & 2) "
			/*  81 */ "!= 0,\n"
			/*  82 */ "			b_lossless_color = (n_color_type & 4) != 0;\n"
			/*  83 */ "		size_t n_base64_length = strlen(p_s_base64);\n"
			/*  84 */ "		size_t n_base64_out_size = (n_base64_length / 4) * 3 +\n"
			/*  85 */ "			max(int(n_base64_length % 4) - 1, 0);\n"
			/*  86 */ "		size_t n_image_size = size_t(n_image_width) * n_image_height;\n"
			/*  87 */ "		int n_chroma_w = (n_image_width + n_subsample - 1) / n_subsample;\n"
			/*  88 */ "		int n_chroma_h = (n_image_height + n_subsample - 1) / n_subsample;\n"
			/*  89 */ "		size_t n_chroma_size = size_t(n_chroma_w) * n_chroma_h * 2;\n"
			/*  90 */ "		size_t n_image_data_size = n_image_size * ((b_alpha)? 2 : 1) +\n"
			/*  91 */ "			((b_gray)? 0 : n_chroma_size);\n"
			/*  92 */ "\n"
			/*  93 */ "		size_t n_prehuff_size = max(n_base64_out_size, n_image_data_size);\n"
			/*  94 */ "		size_t n_temp_buffer_size = n_prehuff_size + n_huff_stage_size;\n"
			/*  95 */ "		uint8_t *p_temp_buffer;\n"
			/*  96 */ "		uint32_t *p_raster;\n"
			/*  97 */ "		if(!(p_temp_buffer = new(std::nothrow) uint8_t[n_temp_buffer_size]) "
			/*  97 */ "||\n"
			/*  98 */ "		   !(p_raster = new(std::nothrow) uint32_t[n_image_size])) {\n"
			/*  99 */ "			delete[] p_temp_buffer; // no effect on null\n"
			/* 100 */ "			return 0;\n"
			/* 101 */ "		}\n"
			/* 102 */ "\n"
			/* 103 */ "		{\n"
			/* 104 */ "			int p_ic_tab[256];\n"
			/* 105 */ "			for(int i = 0; i < 256; ++ i) {\n"
			/* 106 */ "				p_ic_tab[i] = (isalpha(i))? (i | 32) - \'a\' + ((i < \'a\')?"
			/* 106 */ " 0 : 26) :\n"
			/* 107 */ "					(isdigit(i))? i - \'0\' + 52 : (i == \'+\')? 62 : 63;\n"
			/* 108 */ "			}\n"
			/* 109 */ "			uint8_t *p_src = (uint8_t*)p_s_base64, *p_dst = p_temp_buffer;\n"
			/* 110 */ "			for(const uint8_t *p_end = p_src + n_base64_length - 3; p_src < "
			/* 110 */ "p_end; p_src += 4, p_dst += 3) {\n"
			/* 111 */ "				uint8_t p_tmp[] = {p_ic_tab[p_src[1]], p_ic_tab[p_src[2]]};"
			/* 111 */ "\n"
			/* 112 */ "				*p_dst = (p_ic_tab[p_src[0]] << 2) | (p_tmp[0] >> 4);\n"
			/* 113 */ "				p_dst[1] = (p_tmp[0] << 4) | (p_tmp[1] >> 2);\n"
			/* 114 */ "				p_dst[2] = (p_tmp[1] << 6) | p_ic_tab[p_src[3]];\n"
			/* 115 */ "			}\n"
			/* 116 */ "			if(n_base64_length % 4 == 3) {\n"
			/* 117 */ "				uint8_t n_tmp = p_ic_tab[p_src[1]];\n"
			/* 118 */ "				*p_dst = (p_ic_tab[p_src[0]] << 2) | (n_tmp >> 4);\n"
			/* 119 */ "				p_dst[1] = (n_tmp << 4) | ((p_ic_tab[p_src[2]] >> 2) & 0xf);"
			/* 119 */ " // fixed byte order\n"
			/* 120 */ "			} else if(n_base64_length % 4 == 2)\n"
			/* 121 */ "				*p_dst = (p_ic_tab[p_src[0]] << 2) | (p_ic_tab[p_src[1]] >> "
			/* 121 */ "4);\n"
			/* 122 */ "		}\n"
			/* 123 */ "		{\n"
			/* 124 */ "			const uint8_t *p_huff_src = p_temp_buffer, *p_huff_end = p_huff_"
			/* 124 */ "src + n_base64_out_size;\n"
			/* 125 */ "			_ASSERTE(p_huff_src + 16 * sizeof(int32_t) <= p_huff_end);\n"
			/* 126 */ "			const int32_t *p_code_num = (const int32_t*)p_huff_src; p_huff_s"
			/* 126 */ "rc += 16 * sizeof(int32_t);\n"
			/* 127 */ "			int p_min_code[16], p_max_code[16], p_table_off[16], n_code_num "
			/* 127 */ "= 0;\n"
			/* 128 */ "			for(int i = 0, n_cw = 0; i < 16; ++ i, n_cw <<= 1) {\n"
			/* 129 */ "				p_min_code[i] = n_cw;\n"
			/* 130 */ "				p_max_code[i] = (n_cw += p_code_num[i]);\n"
			/* 131 */ "				p_table_off[i] = n_code_num - p_min_code[i];\n"
			/* 132 */ "				n_code_num += p_code_num[i];\n"
			/* 133 */ "			}\n"
			/* 134 */ "			_ASSERTE(p_huff_src + n_code_num <= p_huff_end);\n"
			/* 135 */ "			const uint8_t *p_symbol = p_huff_src; p_huff_src += n_code_num;"
			/* 135 */ "\n"
			/* 136 */ "			uint8_t *p_huff_dest = p_temp_buffer + n_prehuff_size;\n"
			/* 137 */ "			for(int n_byte = 0, n_bit_num = 0, n_counter = n_huff_stage_size"
			/* 137 */ "; n_counter --;) {\n"
			/* 138 */ "				for(int i = 0, n_code = 0;; ++ i) {\n"
			/* 139 */ "					_ASSERTE(i < 16);\n"
			/* 140 */ "					if(!(n_bit_num --)) {\n"
			/* 141 */ "						_ASSERTE(p_huff_src < p_huff_end);\n"
			/* 142 */ "						n_byte = *p_huff_src ++;\n"
			/* 143 */ "						n_bit_num = 7;\n"
			/* 144 */ "					}\n"
			/* 145 */ "					n_code = (n_code << 1) | ((n_byte >> 7) & 1);\n"
			/* 146 */ "					n_byte <<= 1;\n"
			/* 147 */ "					if(n_code >= p_min_code[i] && n_code < p_max_code[i]) {"
			/* 147 */ "\n"
			/* 148 */ "						*p_huff_dest ++ = p_symbol[n_code + p_table_off[i]];"
			/* 148 */ "\n"
			/* 149 */ "						break;\n"
			/* 150 */ "					}\n"
			/* 151 */ "				}\n"
			/* 152 */ "			}\n"
			/* 153 */ "		}\n"
			/* 154 */ "		{\n"
			/* 155 */ "			const uint8_t *p_rle_src = p_temp_buffer + n_prehuff_size,\n"
			/* 156 */ "				*p_src_end = p_rle_src + n_huff_stage_size;\n"
			/* 157 */ "			for(uint8_t *p_rle_dest = p_temp_buffer; p_rle_src != p_src_end;"
			/* 157 */ ") {\n"
			/* 158 */ "				uint8_t n_code = *p_rle_src ++;\n"
			/* 159 */ "				bool b_compressed = n_code & 1;\n"
			/* 160 */ "				int n_run_length = (n_code >> 1) + 1;\n"
			/* 161 */ "				_ASSERTE(p_rle_src + ((b_compressed)? 1 : n_run_length) <= p"
			/* 161 */ "_src_end);\n"
			/* 162 */ "				while(n_run_length --)\n"
			/* 163 */ "					*p_rle_dest ++ = (b_compressed)? *p_rle_src : *p_rle_src"
			/* 163 */ " ++;\n"
			/* 164 */ "				if(b_compressed)\n"
			/* 165 */ "					++ p_rle_src;\n"
			/* 166 */ "			}\n"
			/* 167 */ "		}\n"
			/* 168 */ "\n"
			/* 169 */ "		if(!b_gray) {\n"
			/* 170 */ "			uint8_t *p_y = p_temp_buffer, *p_u = p_y + n_image_size,\n"
			/* 171 */ "				*p_v = p_u + n_chroma_size / 2, *p_a = p_u + n_chroma_size;"
			/* 171 */ "\n"
			/* 172 */ "			UnPredict_ImagePlane(p_y, n_image_width, n_image_height, n_predi"
			/* 172 */ "ctor_y);\n"
			/* 173 */ "			UnPredict_ImagePlane(p_u, n_chroma_w, n_chroma_h, n_predictor_uv"
			/* 173 */ ");\n"
			/* 174 */ "			UnPredict_ImagePlane(p_v, n_chroma_w, n_chroma_h, n_predictor_uv"
			/* 174 */ ");\n"
			/* 175 */ "			if(b_alpha)\n"
			/* 176 */ "				UnPredict_ImagePlane(p_a, n_image_width, n_image_height, n_p"
			/* 176 */ "redictor_a);\n"
			/* 177 */ "			uint32_t *p_dest = p_raster;\n"
			/* 178 */ "			for(int y = 0, h = n_image_height; y < h; ++ y) {\n"
			/* 179 */ "				for(int x = 0, w = n_image_width; x < w; ++ x, ++ p_y, ++ p_"
			/* 179 */ "dest) {\n"
			/* 180 */ "					size_t n_cr_idx = x / n_subsample + size_t(y / n_subsamp"
			/* 180 */ "le) * n_chroma_w;\n"
			/* 181 */ "					uint8_t r, g, b;\n"
			/* 182 */ "					if(!b_lossless_color) {\n"
			/* 183 */ "						int Y = *p_y, u = p_u[n_cr_idx] - 128, v = p_v[n_cr_"
			/* 183 */ "idx] - 128;\n"
			/* 184 */ "						r = uint8_t(max(0, min(255, Y + 1.402f * v)));\n"
			/* 185 */ "						g = uint8_t(max(0, min(255, Y - 0.34414f * u - 0.714"
			/* 185 */ "14f * v)));\n"
			/* 186 */ "						b = uint8_t(max(0, min(255, Y + 1.772f * u))); // JP"
			/* 186 */ "EG-like YUV\n"
			/* 187 */ "					} else {\n"
			/* 188 */ "						int8_t u = p_u[n_cr_idx], v = p_v[n_cr_idx];\n"
			/* 189 */ "						g = *p_y - (u >> 1);\n"
			/* 190 */ "						uint8_t s = g + u;\n"
			/* 191 */ "						r = s - (v >> 1);\n"
			/* 192 */ "						b = r + v; // lifting\n"
			/* 193 */ "					}\n"
			/* 194 */ "					if(b_alpha) {\n"
			/* 195 */ "						*p_dest = (*p_a << 24) | (b << 16) | (g << 8) | r;\n"
			/* 196 */ "						++ p_a;\n"
			/* 197 */ "					} else\n"
			/* 198 */ "						*p_dest = 0xff000000U | (b << 16) | (g << 8) | r;\n"
			/* 199 */ "				}\n"
			/* 200 */ "			}\n"
			/* 201 */ "		} else {\n"
			/* 202 */ "			uint8_t *p_a = p_temp_buffer + n_image_size;\n"
			/* 203 */ "			uint32_t *p_dest = p_raster;\n"
			/* 204 */ "			UnPredict_ImagePlane(p_temp_buffer, n_image_width, n_image_heigh"
			/* 204 */ "t, n_predictor_y);\n"
			/* 205 */ "			if(b_alpha) {\n"
			/* 206 */ "				UnPredict_ImagePlane(p_a, n_image_width, n_image_height, n_p"
			/* 206 */ "redictor_a);\n"
			/* 207 */ "				for(const uint8_t *p_y = p_temp_buffer,\n"
			/* 208 */ "				   *p_end = p_y + n_image_size; p_y != p_end; ++ p_y, ++ p_a"
			/* 208 */ ")\n"
			/* 209 */ "					*p_dest ++ = (*p_a << 24) | (*p_y << 16) | (*p_y << 8) |"
			/* 209 */ " *p_y; // gray / alpha\n"
			/* 210 */ "			} else {\n"
			/* 211 */ "				for(const uint8_t *p_y = p_temp_buffer,\n"
			/* 212 */ "				   *p_end = p_y + n_image_size; p_y != p_end; ++ p_y)\n"
			/* 213 */ "					*p_dest ++ = 0xff000000U | (*p_y << 16) | (*p_y << 8) | "
			/* 213 */ "*p_y; // gray\n"
			/* 214 */ "			}\n"
			/* 215 */ "		}\n"
			/* 216 */ "\n"
			/* 217 */ "		delete[] p_temp_buffer;\n"
			/* 218 */ "\n"
			/* 219 */ "		return p_raster;\n"
			/* 220 */ "	}\n";

		return p_s_text;
	}
};

#endif // _____DECOMPRESS64_H_INCLUDED
