#include "../../UberLame_src/NewFix.h"
#include "../../UberLame_src/CallStack.h"
#include <stdio.h>
#include "../../UberLame_src/Integer.h"
#include "../../UberLame_src/TypeName.h"
#include "../../UberLame_src/iface/PNGLoad.h"
#include "../../UberLame_src/Crc.h"

template <class CImg>
static void TestDecompress(const CImg &tag);

namespace gll {

#include "OpenGLLogo_Test85_RGB_lossy.h"
#undef __OPENGL_LOGO_2_0_TGA_INCLUDED // well ... this is unfortunate, guess I didnt count on this
#include "OpenGLLogo_Test85_RGBA_lossy.h"
#undef __OPENGL_LOGO_2_0_TGA_INCLUDED
#include "OpenGLLogo_Test85_RGB_lossless.h"
#undef __OPENGL_LOGO_2_0_TGA_INCLUDED
#include "OpenGLLogo_Test85_RGBA_lossless.h"
#undef __OPENGL_LOGO_2_0_TGA_INCLUDED
#include "OpenGLLogo_Test85_Y_lossy.h"
#undef __OPENGL_LOGO_2_0_TGA_INCLUDED
#include "OpenGLLogo_Test85_YA_lossy.h"
#undef __OPENGL_LOGO_2_0_TGA_INCLUDED
#include "OpenGLLogo_Test85_Y_lossless.h"
#undef __OPENGL_LOGO_2_0_TGA_INCLUDED
#include "OpenGLLogo_Test85_YA_lossless.h"

#undef __OPENGL_LOGO_2_0_TGA_INCLUDED
#include "OpenGLLogo_Test64_RGB_lossy.h"
#undef __OPENGL_LOGO_2_0_TGA_INCLUDED
#include "OpenGLLogo_Test64_RGBA_lossy.h"
#undef __OPENGL_LOGO_2_0_TGA_INCLUDED
#include "OpenGLLogo_Test64_RGB_lossless.h"
#undef __OPENGL_LOGO_2_0_TGA_INCLUDED
#include "OpenGLLogo_Test64_RGBA_lossless.h"
#undef __OPENGL_LOGO_2_0_TGA_INCLUDED
#include "OpenGLLogo_Test64_Y_lossy.h"
#undef __OPENGL_LOGO_2_0_TGA_INCLUDED
#include "OpenGLLogo_Test64_YA_lossy.h"
#undef __OPENGL_LOGO_2_0_TGA_INCLUDED
#include "OpenGLLogo_Test64_Y_lossless.h"
#undef __OPENGL_LOGO_2_0_TGA_INCLUDED
#include "OpenGLLogo_Test64_YA_lossless.h"

#undef __OPENGL_LOGO_2_0_TGA_INCLUDED
#include "OpenGLLogo_Test85_RGB_lossy_multi.h"
#undef __OPENGL_LOGO_2_0_TGA_INCLUDED
#include "OpenGLLogo_Test85_RGBA_lossy_multi.h"
#undef __OPENGL_LOGO_2_0_TGA_INCLUDED
#include "OpenGLLogo_Test85_RGB_lossless_multi.h"
#undef __OPENGL_LOGO_2_0_TGA_INCLUDED
#include "OpenGLLogo_Test85_RGBA_lossless_multi.h"
#undef __OPENGL_LOGO_2_0_TGA_INCLUDED
#include "OpenGLLogo_Test85_Y_lossy_multi.h"
#undef __OPENGL_LOGO_2_0_TGA_INCLUDED
#include "OpenGLLogo_Test85_YA_lossy_multi.h"
#undef __OPENGL_LOGO_2_0_TGA_INCLUDED
#include "OpenGLLogo_Test85_Y_lossless_multi.h"
#undef __OPENGL_LOGO_2_0_TGA_INCLUDED
#include "OpenGLLogo_Test85_YA_lossless_multi.h"

#undef __OPENGL_LOGO_2_0_TGA_INCLUDED
#include "OpenGLLogo_Test64_RGB_lossy_multi.h"
#undef __OPENGL_LOGO_2_0_TGA_INCLUDED
#include "OpenGLLogo_Test64_RGBA_lossy_multi.h"
#undef __OPENGL_LOGO_2_0_TGA_INCLUDED
#include "OpenGLLogo_Test64_RGB_lossless_multi.h"
#undef __OPENGL_LOGO_2_0_TGA_INCLUDED
#include "OpenGLLogo_Test64_RGBA_lossless_multi.h"
#undef __OPENGL_LOGO_2_0_TGA_INCLUDED
#include "OpenGLLogo_Test64_Y_lossy_multi.h"
#undef __OPENGL_LOGO_2_0_TGA_INCLUDED
#include "OpenGLLogo_Test64_YA_lossy_multi.h"
#undef __OPENGL_LOGO_2_0_TGA_INCLUDED
#include "OpenGLLogo_Test64_Y_lossless_multi.h"
#undef __OPENGL_LOGO_2_0_TGA_INCLUDED
#include "OpenGLLogo_Test64_YA_lossless_multi.h"

#undef __OPENGL_LOGO_2_0_TGA_INCLUDED
#include "OpenGLLogo_Test85_RGB_lossy_SD.h"
#undef __OPENGL_LOGO_2_0_TGA_INCLUDED
#include "OpenGLLogo_Test85_RGBA_lossy_SD.h"
#undef __OPENGL_LOGO_2_0_TGA_INCLUDED
#include "OpenGLLogo_Test85_RGB_lossless_SD.h"
#undef __OPENGL_LOGO_2_0_TGA_INCLUDED
#include "OpenGLLogo_Test85_RGBA_lossless_SD.h"
#undef __OPENGL_LOGO_2_0_TGA_INCLUDED
#include "OpenGLLogo_Test85_Y_lossy_SD.h"
#undef __OPENGL_LOGO_2_0_TGA_INCLUDED
#include "OpenGLLogo_Test85_YA_lossy_SD.h"
#undef __OPENGL_LOGO_2_0_TGA_INCLUDED
#include "OpenGLLogo_Test85_Y_lossless_SD.h"
#undef __OPENGL_LOGO_2_0_TGA_INCLUDED
#include "OpenGLLogo_Test85_YA_lossless_SD.h"

#undef __OPENGL_LOGO_2_0_TGA_INCLUDED
#include "OpenGLLogo_Test64_RGB_lossy_SD.h"
#undef __OPENGL_LOGO_2_0_TGA_INCLUDED
#include "OpenGLLogo_Test64_RGBA_lossy_SD.h"
#undef __OPENGL_LOGO_2_0_TGA_INCLUDED
#include "OpenGLLogo_Test64_RGB_lossless_SD.h"
#undef __OPENGL_LOGO_2_0_TGA_INCLUDED
#include "OpenGLLogo_Test64_RGBA_lossless_SD.h"
#undef __OPENGL_LOGO_2_0_TGA_INCLUDED
#include "OpenGLLogo_Test64_Y_lossy_SD.h"
#undef __OPENGL_LOGO_2_0_TGA_INCLUDED
#include "OpenGLLogo_Test64_YA_lossy_SD.h"
#undef __OPENGL_LOGO_2_0_TGA_INCLUDED
#include "OpenGLLogo_Test64_Y_lossless_SD.h"
#undef __OPENGL_LOGO_2_0_TGA_INCLUDED
#include "OpenGLLogo_Test64_YA_lossless_SD.h"

} // ~gll

void Test_Box(); // split to a different compile unit to reduce heap space needed by the compiler

int main(int UNUSED(n_arg_num), const char **UNUSED(p_arg_list))
{
#ifndef _DEBUG
	fprintf(stderr, "error: not in debug mode; some issues may be missed\n");
#endif // !_DEBUG

	TestDecompress(gll::CBase85RGB());
	TestDecompress(gll::CBase85RGBA());
	TestDecompress(gll::CBase85RGBL());
	TestDecompress(gll::CBase85RGBAL());
	TestDecompress(gll::CBase85Y());
	TestDecompress(gll::CBase85YA());
	TestDecompress(gll::CBase85YL());
	TestDecompress(gll::CBase85YAL());

	TestDecompress(gll::CBase64RGB());
	TestDecompress(gll::CBase64RGBA());
	TestDecompress(gll::CBase64RGBL());
	TestDecompress(gll::CBase64RGBAL());
	TestDecompress(gll::CBase64Y());
	TestDecompress(gll::CBase64YA());
	TestDecompress(gll::CBase64YL());
	TestDecompress(gll::CBase64YAL());

	TestDecompress(gll::CBase85RGB_M());
	TestDecompress(gll::CBase85RGBA_M());
	TestDecompress(gll::CBase85RGBL_M());
	TestDecompress(gll::CBase85RGBAL_M());
	TestDecompress(gll::CBase85Y_M());
	TestDecompress(gll::CBase85YA_M());
	TestDecompress(gll::CBase85YL_M());
	TestDecompress(gll::CBase85YAL_M());

	TestDecompress(gll::CBase64RGB_M());
	TestDecompress(gll::CBase64RGBA_M());
	TestDecompress(gll::CBase64RGBL_M());
	TestDecompress(gll::CBase64RGBAL_M());
	TestDecompress(gll::CBase64Y_M());
	TestDecompress(gll::CBase64YA_M());
	TestDecompress(gll::CBase64YL_M());
	TestDecompress(gll::CBase64YAL_M());

	TestDecompress(gll::CBase85RGB_SD());
	TestDecompress(gll::CBase85RGBA_SD());
	TestDecompress(gll::CBase85RGBL_SD());
	TestDecompress(gll::CBase85RGBAL_SD());
	TestDecompress(gll::CBase85Y_SD());
	TestDecompress(gll::CBase85YA_SD());
	TestDecompress(gll::CBase85YL_SD());
	TestDecompress(gll::CBase85YAL_SD());

	TestDecompress(gll::CBase64RGB_SD());
	TestDecompress(gll::CBase64RGBA_SD());
	TestDecompress(gll::CBase64RGBL_SD());
	TestDecompress(gll::CBase64RGBAL_SD());
	TestDecompress(gll::CBase64Y_SD());
	TestDecompress(gll::CBase64YA_SD());
	TestDecompress(gll::CBase64YL_SD());
	TestDecompress(gll::CBase64YAL_SD());

	Test_Box();

	printf("done\n");

	return 0;
}

template <class CImg>
static void TestDecompress(const CImg &tag)
{
#if _MSC_VER <= 1200
	std::string s_type_id = typeid(CImg).name();
#else //  _MSC_VER <= 1200
	std::string s_type_id = s_TypeName<CImg>(); // this is broken in VC6, all the instances return the same value
#endif //  _MSC_VER <= 1200
	uint32_t *p_data = CImg::p_Decompress();
	if(!p_data)
		fprintf(stderr, "error: decompress for %s failed\n", s_type_id.c_str());
	else {
		const uint32_t n_decoded_image_crc32 = CCrc_32::n_Finalize(CCrc_32::n_Crc(CImg::n_Width() *
			CImg::n_Height() * sizeof(uint32_t), p_data, CCrc_32::n_Start()));
		if(n_decoded_image_crc32 == CImg::n_CRC32())
			printf("decompress for %s ok (0x%08x)\n", s_type_id.c_str(), n_decoded_image_crc32);
		else {
			printf("decompress for %s gave different image (0x%08x rather than 0x%08x)\n",
				s_type_id.c_str(), n_decoded_image_crc32, CImg::n_CRC32());
		}

		TBmp t_bitmap = {0};
		t_bitmap.n_former_bpc = 8;
		t_bitmap.b_alpha = CImg::b_Alpha();
		t_bitmap.b_grayscale = CImg::b_Grayscale();
		t_bitmap.n_width = CImg::n_Width();
		t_bitmap.n_height = CImg::n_Height();
		t_bitmap.p_buffer = p_data;

		s_type_id += "_test.png";
		std::replace(s_type_id.begin(), s_type_id.end(), ':', '_');
		if(!CPngCodec::Save_PNG(s_type_id.c_str(), t_bitmap, true))
			fprintf(stderr, "error: failed to save \'%s\'\n", s_type_id.c_str());

		delete[] p_data;
	}
}
